import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.Sprite;

/**
 */
public class Dashboard {
	private static final int HPF8 = GameView.HPF8;
	private static final int VPF8 = GameView.VPF8;
	// dashboard variables
	private static int mDamageLineY = 0;
	private static int mDamageLineX = 0;
	/** Particles and clouds */
	private static final Particle[] mParticles = new Particle[32];
	private static boolean mIsSparksAnimation = false;
	/** false - start sparks animation, true - animation finished */
	private static boolean mIsSparksAnimationFinished = true;
	/** false - start cloud animation, true - animation finished */
	private static boolean mIsCloudAnimationFinished = true;
	/** time to show lap time */
	private static int mShowLapTimeTimer = 0;// int16
	/** true, if lap time was improved */
	private static boolean mIsLapTimeImproved = false;
	/** timer to update car to car distance indicator */
	private static int mUpdateDistanceTimer = 0;
	/** race time in %1m:%2ss.%2ms */
	public static final char[] mStrLapTime = { ' ', ':', ' ', ' ', '.', ' ', ' ' };
	/** best lap time in %1m:%2ss.%2ms */
	private static final char[] mStrBestLapTime = { ' ', ':', ' ', ' ', '.', ' ', ' ' };
	/** car to car distance */
	private static final char[] mStrDistance = { ' ', ' ', ' ', ' ', ' ' };
	private static final char[] mStrLap = { 'L', ' ' };
	private static final char[] mStrBoost = { 'B', ' ', ' ', ' ' };
	// end dashboard variables
	private static Image imgLightWatch = null;
	private static Image[] imgClouds = new Image[7];
	private static Image imgWatch = null;
	private static int mWheelFrameNumber = 0; // int8
	private static Image imgFlag = null;
	private static Image imgRightCorner = null;
	// images
	private static Image imgCockpit = null;
	private static int nFlameNumber = 0; // int8
	private static Image imgLeftPillar = null;
	private static int mWheelSpeed = 0; // int16
	private static int mCloudFrameNumber = 0; // int8
	private static Image[] imgRightWheel = new Image[3];
	private static Image imgTop = null;
	private static Image imgRightPillar = null;
	/** 3 frames for 4 left exhaust pipe */
	private static Image[] imgLeftFlames = new Image[3 * 4];
	private static Image imgLeftCorner = null;
	/** 3 frames for 4 right exhaust pipe */
	private static Image[] imgRightFlames = new Image[3 * 4];
	private static int mWheelRunDistance = 0; // int16
	private static Image[] imgLeftWheel = new Image[3];
	private static Image imgSteer = null;
	private static Image imgChain = null;
	private static int mFlameFrameNumber = 0; // int8
	//
	public static int init() {
		//
		for( int i = 0; i < mParticles.length; i++ ) {
			final Particle p = new Particle();
			p.mY_fp8 = GameView.SCREEN_HEIGHT << 8;// off screen
			mParticles[i] = p;
		}
		// load images
		try {
			//createOffscreenBuffer();
			//setIconImage( new ImageIcon( getImage("ico") ).getImage() );
			//
			imgCockpit = Support.getScaledImage( GameView.getImage("db"), (320 * HPF8 + 128) / 256, (77 * VPF8 + 128) / 256 );
			//
			imgSteer = Support.getScaledImage( GameView.getImage("steer"), (10 * HPF8 + 128) / 256, (5 * VPF8 + 128) / 256 );
			//
			imgFlag = Support.getScaledImage( GameView.getImage("flag"), (12 * HPF8 + 128) / 256, (8 * VPF8 + 128) / 256 );
			//
			imgTop = Support.getScaledImage( GameView.getImage("top"), (24 * HPF8 + 128) / 256, (16 * VPF8 + 128) / 256 );
			//
			Image bimg = GameView.getImage("watch");
			imgWatch = Support.getScaledImage( Image.createImage( bimg, 0, 0, 12, 7, Sprite.TRANS_NONE ),
					(12 * HPF8 + 128) / 256, (7 * VPF8 + 128) / 256 );
			imgLightWatch = Support.getScaledImage( Image.createImage( bimg, 12, 0, 12, 7, Sprite.TRANS_NONE ),
					(12 * HPF8 + 128) / 256, (7 * VPF8 + 128) / 256 );
			//
			bimg = GameView.getImage("pillar");
			imgLeftPillar = Support.getScaledImage( Image.createImage( bimg, 0, 0, 16, 101, Sprite.TRANS_NONE ),
					(16 * HPF8 + 128) / 256, (101 * VPF8 + 128) / 256 );
			imgRightPillar = Support.getScaledImage( Image.createImage( bimg, 16, 0, 16, 101, Sprite.TRANS_NONE ),
					(16 * HPF8 + 128) / 256, (101 * VPF8 + 128) / 256 );
			//
			bimg = GameView.getImage("corner");
			imgLeftCorner = Support.getScaledImage( Image.createImage( bimg, 0, 0, 22, 22, Sprite.TRANS_NONE ),
					(22 * HPF8 + 128) / 256, (22 * VPF8 + 128) / 256 );
			imgRightCorner = Support.getScaledImage( Image.createImage( bimg, 22, 0, 22, 22, Sprite.TRANS_NONE ),
					(22 * HPF8 + 128) / 256, (22 * VPF8 + 128) / 256 );
			// wheels
			bimg = GameView.getImage("w");
			for( int i = 0; i < imgLeftWheel.length; i++ ) {
				imgLeftWheel[i] = Support.getScaledImage( Image.createImage( bimg, i * 24, 0, 24, 55, Sprite.TRANS_NONE ),
						(24 * HPF8 + 128) / 256, (55 * VPF8 + 128) / 256 );
			}
			for( int i = 0; i < imgRightWheel.length; i++ ) {
				imgRightWheel[i] = Support.getScaledImage( Image.createImage( bimg, 144 - (i + 1) * 24, 0, 24, 55, Sprite.TRANS_NONE ),
						(24 * HPF8 + 128) / 256, (55 * VPF8 + 128) / 256 );
			}
			// chain
			imgChain = Support.getScaledImage( GameView.getImage("chain"),
					(10 * HPF8 + 128) / 256, (16 * VPF8 + 128) / 256 );
			// flames
			bimg = GameView.getImage("f");
			for( int i = 0; i < (imgLeftFlames.length >> 2); i++ ) {
				imgLeftFlames[0 * 3 + i] = Support.getScaledImage( Image.createImage( bimg, i * 15, 0, 15, 20, Sprite.TRANS_NONE ),
						(15 * HPF8 + 128) / 256, (20 * VPF8 + 128) / 256 );
				imgRightFlames[0 * 3 + i] = Support.getScaledImage( Image.createImage( bimg, 90 - (i + 1) * 15, 0, 15, 20, Sprite.TRANS_NONE ),
						(15 * HPF8 + 128) / 256, (20 * VPF8 + 128) / 256 );
				imgLeftFlames[1 * 3 + i] = Support.getScaledImage( Image.createImage( bimg, i * 15, 20, 15, 14, Sprite.TRANS_NONE ),
						(15 * HPF8 + 128) / 256, (14 * VPF8 + 128) / 256 );
				imgRightFlames[1 * 3 + i] = Support.getScaledImage( Image.createImage( bimg, 90 - (i + 1) * 15, 20, 15, 14, Sprite.TRANS_NONE ),
						(15 * HPF8 + 128) / 256, (14 * VPF8 + 128) / 256 );
				imgLeftFlames[2 * 3 + i] = Support.getScaledImage( Image.createImage( bimg, i * 14, 34, 14, 14, Sprite.TRANS_NONE ),
						(14 * HPF8 + 128) / 256, (14 * VPF8 + 128) / 256 );
				imgRightFlames[2 * 3 + i] = Support.getScaledImage( Image.createImage( bimg, 90 - (i + 1) * 14, 34, 14, 14, Sprite.TRANS_NONE ),
						(14 * HPF8 + 128) / 256, (14 * VPF8 + 128) / 256 );
				imgLeftFlames[3 * 3 + i] = Support.getScaledImage( Image.createImage( bimg, i * 9, 48, 9, 10, Sprite.TRANS_NONE ),
						(9 * HPF8 + 128) / 256, (10 * VPF8 + 128) / 256 );
				imgRightFlames[3 * 3 + i] = Support.getScaledImage( Image.createImage( bimg, 90 - (i + 1) * 9, 48, 9, 10, Sprite.TRANS_NONE ),
						(9 * HPF8 + 128) / 256, (10 * VPF8 + 128) / 256 );
			}
			bimg = GameView.getImage("clouds");
			for( int i = 0; i < imgClouds.length; i++ ) {
				imgClouds[i] = Support.getScaledImage( Image.createImage( bimg, 0, i * 39, 65, 39, Sprite.TRANS_NONE ),
						(65 * HPF8 + 128) / 256, (39 * VPF8 + 128) / 256 );
			}
		}
		catch(Exception ie) {
			System.out.println( ie.getMessage() );
			//ie.printStackTrace();
			return -1;
		}
		return 0;
	}
	public static void initRace() {
		mIsSparksAnimationFinished = true;
		mIsCloudAnimationFinished = true;
		// init damage line
		mDamageLineY = 2 * VPF8 / 256;// 2 is vertical margin
		mDamageLineX = 22 * HPF8 / 256;// 22 is horizontal margin, edge pillar width
		// init car to car distance
		mStrDistance[0] = ' ';
		for( int i = 1; i < mStrDistance.length; i++ ) mStrDistance[i] = '0';
		// lap time
		mShowLapTimeTimer = 0;
		mStrLapTime[1] = ':';
		mStrLapTime[4] = '.';
		for( int i = 0; i < mStrBestLapTime.length; i++ ) mStrBestLapTime[i] = ' ';
		//for( int i = 0; i < mStrRaceTime.length; i++ ) mStrRaceTime[i] = ' ';
		mWheelSpeed = 0;
	}
	public static void stopAnimation() {
		mWheelSpeed = 0;
		mIsCloudAnimationFinished = true;
		mIsSparksAnimationFinished = true;
	}
	public static void freezeLapTime(boolean isImproved) {
		mShowLapTimeTimer = (3 * 1000 / (int)GameView.REFRESH_PERIOD);// 3 sec to show lap time
		if( isImproved ) {//copy best lap time
			System.arraycopy( mStrLapTime, 0, mStrBestLapTime, 0, mStrBestLapTime.length );
		}
		mIsLapTimeImproved = isImproved;
	}
	/** Render car pillars and set clip area */
	public static void renderPillars(final Graphics g) {
		final int cockpit_height = (77 * VPF8 + 128) / 256;
		final int pillar_width = (16 * HPF8 + 128) / 256;
		final int top_pillar_width = (24 * HPF8 + 128) / 256;
		final int top_pillar_height = (16 * VPF8 + 128) / 256;
		final int edge_pillar_width = (22 * HPF8 + 128) / 256;
		final int edge_pillar_height = (22 * VPF8 + 128) / 256;
		//
		g.drawImage( imgCockpit, 0, GameView.SCREEN_HEIGHT - cockpit_height, Graphics.LEFT | Graphics.TOP );
		g.drawImage( imgLeftPillar, 0, edge_pillar_height, Graphics.LEFT | Graphics.TOP );
		g.drawImage( imgRightPillar, GameView.SCREEN_WIDTH - pillar_width, edge_pillar_height, Graphics.LEFT | Graphics.TOP );
		final int right = GameView.SCREEN_WIDTH - edge_pillar_width;
		for( int h = edge_pillar_width; h < right; h += top_pillar_width ) {
			g.drawImage( imgTop, h, 0, Graphics.LEFT | Graphics.TOP );
		}
		g.drawImage( imgLeftCorner, 0, 0, Graphics.LEFT | Graphics.TOP );
		g.drawImage( imgRightCorner, GameView.SCREEN_WIDTH - edge_pillar_width, 0, Graphics.LEFT | Graphics.TOP );
		// set clip to prevent drawing on pillars
		g.setClip( pillar_width, top_pillar_height, GameView.SCREEN_WIDTH - pillar_width * 2, GameView.SCREEN_HEIGHT - top_pillar_height );
	}
	private static void renderSparks(final Graphics g, int speed, boolean isContinue) {
		final int cockpit_height = 77 * VPF8 / 256;
		//
		g.setColor( 0xffff00 );
		speed = (4096 << 8) + (speed << (8 + 4));
		final int visible_y_fp8 = (GameView.SCREEN_HEIGHT - cockpit_height + 22 * VPF8 / 256) << 8;
		boolean is_finished = true;
		for( int i = 0; i < mParticles.length; i++ ) {
			final Particle p = mParticles[i];
			if( isContinue && (p.mY_fp8 > visible_y_fp8 || p.mX_fp8 < 0 || p.mX_fp8 > (GameView.SCREEN_WIDTH << 8)) ) {
				p.mY_fp8 = visible_y_fp8;
				p.mX_fp8 = GameView.SCREEN_HALFWIDTH << 8;
				int acceleration_fp8 = speed;
				acceleration_fp8 /= (int)(256 * 3 * 1000 * 1000 / GameView.REFRESH_PERIOD / GameView.REFRESH_PERIOD / VPF8);
				acceleration_fp8 += GameView.mRandom.nextInt( acceleration_fp8 );
				p.mDY_fp8 -= acceleration_fp8;
				p.mDX_fp8 = (GameView.mRandom.nextInt( GameView.SCREEN_WIDTH ) - GameView.SCREEN_HALFWIDTH) << 4;
			}
			p.mY_fp8 += p.mDY_fp8;
			if( p.mY_fp8 <= visible_y_fp8 ) is_finished = false;
			// gravitation, 1.7 m/s
			p.mDY_fp8 += (int)(256 * 170 * VPF8 / 256 * GameView.REFRESH_PERIOD * GameView.REFRESH_PERIOD / 1000 / 1000);
			p.mX_fp8 += p.mDX_fp8;
			g.fillRect( p.mX_fp8 >> 8, p.mY_fp8 >> 8, 2 * HPF8 / 256, 2 * VPF8 / 256 );
		}
		mIsSparksAnimationFinished = is_finished;
	}
	public static void initClouds() {
		if( mIsCloudAnimationFinished ) {// initiate clouds
			mIsCloudAnimationFinished = false;
			SoundManager.play( SoundManager.OFF_ROAD, 256, 256 );
			final int cockpit_height = 77 * VPF8 / 256;
			final int cloud_width = 65 * HPF8 / 256;
			//
			final int start_y_fp8 = (GameView.SCREEN_HEIGHT - cockpit_height + 22 * VPF8 / 256) << 8;
			for( int i = 0; i < mParticles.length; i++ ) {
				final Particle p = mParticles[i];
				p.mFrame = GameView.mRandom.nextInt( 7 );
				p.mY_fp8 = start_y_fp8;
				p.mX_fp8 = GameView.mRandom.nextInt( GameView.SCREEN_WIDTH - cloud_width ) << 8;
				// 8.5 m/s
				final int acceleration_fp8 = (int)(256 * 850 * VPF8 / 256 * GameView.REFRESH_PERIOD * GameView.REFRESH_PERIOD / 1000 / 1000);
				p.mDY_fp8 = -(acceleration_fp8 + GameView.mRandom.nextInt( acceleration_fp8 ));
				p.mDX_fp8 = (GameView.mRandom.nextInt( GameView.SCREEN_WIDTH ) - GameView.SCREEN_HALFWIDTH) << 2;
			}
		}
	}
	public static void renderClouds(final Graphics g) {
		if( mIsCloudAnimationFinished ) {
			return;
		}
		final int cockpit_height = 77 * VPF8 / 256;
		//
		int frame_shift = 0;
		if( ++mCloudFrameNumber >= (int)(1000 / GameView.REFRESH_PERIOD / 8) ) {
			mCloudFrameNumber = 0;
			frame_shift = 1;//mRandom.nextInt( 7 );
		}
		boolean is_finished = true;
		final int visible_y_fp8 = (GameView.SCREEN_HEIGHT - cockpit_height + 22 * VPF8 / 256) << 8;
		for( int i = 0; i < mParticles.length; i++ ) {
			final Particle p = mParticles[i];
			if( p.mY_fp8 <= visible_y_fp8 ) is_finished = false;
			p.mY_fp8 += p.mDY_fp8;
			// gravitation, 0.66 m/s
			p.mDY_fp8 += (int)(256 * 66 * VPF8 / 256 * GameView.REFRESH_PERIOD * GameView.REFRESH_PERIOD / 1000 / 1000);
			p.mX_fp8 += p.mDX_fp8;
			//
			p.mFrame += frame_shift;
			if( p.mFrame >= 7 ) p.mFrame -= 7;
			g.drawImage( imgClouds[p.mFrame], p.mX_fp8 >> 8, p.mY_fp8 >> 8, Graphics.LEFT | Graphics.TOP );
		}
		mIsCloudAnimationFinished = is_finished;
	}
	private static void renderChains(final Graphics g, int phase) {
		final int cockpit_height = 77 * VPF8 / 256;
		final int chain_width = 10 * HPF8 / 256;
		final int chain_pos = 55 * HPF8 / 256;
		final int chain_height = 16 * VPF8 / 256;
		final int chain_right_x = GameView.SCREEN_WIDTH - (chain_pos + chain_width);
		final int bottom = GameView.SCREEN_HEIGHT - cockpit_height + chain_width;
		final int step = (bottom - 0) / PlayerCar.CHAIN_RELEASE_TIME;
		//
		for( int y = bottom - step * phase; y > 0; y -= chain_height ) {
			g.drawImage( imgChain, chain_pos, y, Graphics.LEFT | Graphics.TOP );// left
			g.drawImage( imgChain, chain_right_x, y, Graphics.LEFT | Graphics.TOP );// rightt
		}
	}
	private static void renderDamage(final Graphics g, int damage) {
		final int top_pillar_height = 16 * VPF8 / 256;
		final int pillar_width = 16 * HPF8 / 256;
		final int damage_line_margin = 22;// not scaled, edge pillar width
		final int damage_line_pos_y = 3 * VPF8 / 256;
		final int damage_line_deviation = (3 * VPF8 / 256) < 3 ? 3 : (3 * VPF8 / 256);
		//
		g.setClip( 0, 0, GameView.SCREEN_WIDTH, top_pillar_height );
		//
		// draw damage line
		//g.setColor( Color.RED );
		//final int damage_line_length = damage * (SCREEN_WIDTH - damage_line_margin * 2) / Car.DAMAGE_LIMIT;
		//g.fillRect( damage_line_margin, 2 * PF, damage_line_length, 4 * PF );
		final int damage_line_end = (damage_line_margin + damage * (256 * GameView.SCREEN_WIDTH / HPF8 - damage_line_margin * 2) / Car.DAMAGE_LIMIT) * HPF8 / 256;
		//
		final int step_x = (1 * HPF8 / 256 < 1)? 1 : 1 * HPF8 / 256;
		final int step_y = (1 * VPF8 / 256 < 1)? 1 : 1 * VPF8 / 256;
		for( int i = mDamageLineX; i < damage_line_end; i += step_x ) {
			int direction = GameView.mRandom.nextInt( 3 );// 0 - down, 1 - up, 2 - straight
			int color = 0x804040;
			if( direction == 0 ) {
				if( mDamageLineY < (damage_line_pos_y + damage_line_deviation - step_y) ) {
					mDamageLineY += step_y;
					color = 0xc08080;// to mark falling
				}
				//if( mDamageLineY < (damage_line_pos_y + damage_line_deviation - 1) ) mDamageLineY++;
			}
			if( --direction == 0 ) {
				if( mDamageLineY > damage_line_pos_y ) mDamageLineY -= step_y;
			}
			// change color to mark increment
			//g.setColor( i == mDamageLineX ? new Color( 192, 128, 128 ) : new Color( 128, 64, 64 ) );
			g.setColor( color );
			g.fillRect( i, mDamageLineY, step_x, step_y );
			g.setColor( 0 );
			g.fillRect( i, mDamageLineY + step_y, step_x, step_y << 1 );
		}
		mDamageLineX = damage_line_end;
		//
		// draw opponent damage line to test
		//g.setColor( Color.BLUE );
		//final int opp_damage_line_length = mOpponentCar.mDamage * (SCREEN_WIDTH - damage_line_margin * 2) / Car.DAMAGE_LIMIT;
		//g.fillRect( damage_line_margin, (2 + 4) * PF, opp_damage_line_length, 4 * PF );
		// draw damage count
		//g.setColor( Color.BLACK );
		//g.drawString( Integer.toString( damage ), damage_line_margin, 2 * PF + FONT_BASELINE );
		//
		g.setClip( pillar_width, top_pillar_height, GameView.SCREEN_WIDTH - pillar_width * 2, GameView.SCREEN_HEIGHT - top_pillar_height );
	}
	private static void calculateWheelFrameNumber(final Car car) {
		if( car.mIsTouchingRoad ) {
			mWheelSpeed = Math.abs( car.mSpeed_fp8 );
		} else {
			mWheelSpeed -= mWheelSpeed >> 4;
		}
		mWheelRunDistance += mWheelSpeed;
		if( mWheelRunDistance > (int)(256 * 1000 / GameView.REFRESH_PERIOD) ) {
			mWheelRunDistance = 0;
			if( car.mSpeed_fp8 > 0 ) {
				if( ++mWheelFrameNumber >= imgLeftWheel.length ) mWheelFrameNumber = 0;
				return;
			}
			if( --mWheelFrameNumber < 0 ) mWheelFrameNumber += imgLeftWheel.length;
		}
	}
	/**
	 * @param ms10 - time in ms / 10
	 * @return filled mStrLapTime[0,2,3,5,6]
	 */
	public static void convertMsToChars(final int ms10) {
		if( ms10 >= 0x00ffffff ) {
			for( int i = 0; i < mStrLapTime.length; i++ ) mStrLapTime[i] = '-';
			return;
		}
		final int min = Math.min( ms10 / 6000, 9 );
		final int sec = (ms10 / 100) % 60;
		mStrLapTime[0] = (char)(min + '0');
		mStrLapTime[2] = (char)(sec / 10 + '0');
		mStrLapTime[3] = (char)(sec % 10 + '0');
		mStrLapTime[5] = (char)(((ms10 / 10) % 10) + '0');
		mStrLapTime[6] = (char)((ms10 % 10) + '0');
	}
	public static void render(final Graphics g, final PlayerCar car, final int keys, final boolean isOpponentBehind) {
		calculateWheelFrameNumber( car );
		int speed = Math.max( 0, car.getSpeedKmH() );
		if( car.mIsOnRoad && (car.mIsScratchSide || (car.mDamage >= Car.DAMAGE_LIMIT)) ) {
			mIsSparksAnimation = true;
			mIsSparksAnimationFinished = false;
		}
		if( ! mIsSparksAnimationFinished ) {
			renderSparks( g, speed, mIsSparksAnimation );
			mIsSparksAnimation = false;
		}
		if( car.mChainReleaseCounter < PlayerCar.CHAIN_RELEASE_TIME ) {
			if( ! car.mIsOnChains ) ++car.mChainReleaseCounter;
			renderChains( g, car.mChainReleaseCounter );
		}
		// draw marker. 8px/10kmh. starts from 10 kmh.
		final int indicator_length = Math.max( Math.min( speed * (HPF8 / 256 * 8) / 10, 155 * HPF8 / 256 ) - 10 * HPF8 / 256 * 8 / 10, 0 );
		// calculate cockpit y position
		//final int s = (SCALE << PRECISION_LOG2) / (car.BONNET + CAMERA_FOV);
		final int cockpit_width = 320 * HPF8 / 256;
		final int cockpit_height = (77 * VPF8 + 128) / 256;
		final int cockpit_x = (GameView.SCREEN_WIDTH - cockpit_width) >> 1;
		final int cockpit_right_x = cockpit_x + cockpit_width;
		//final int dz = -20;
		final int cockpit_y = GameView.SCREEN_HEIGHT - cockpit_height;//LOOK_Y - ((s * dz) >> PRECISION_LOG2);
		// draw wheels
		final int wscale = (Render.SCALE << Camera.PRECISION_LOG2) / (Car.WHEEL_FRONT_Y + Render.CAMERA_FOV);
		final int wy_right = Render.LOOK_Y - (wscale * (car.mFrontRightWheelBottom + (Car.WHEEL_RADIUS << 1) - Car.LOOK_Z) >> Camera.PRECISION_LOG2);
		final int wy_left = Render.LOOK_Y - (wscale * (car.mFrontLeftWheelBottom + (Car.WHEEL_RADIUS << 1) - Car.LOOK_Z) >> Camera.PRECISION_LOG2);
		g.drawImage( imgLeftWheel[mWheelFrameNumber], cockpit_x + 16 * HPF8 / 256, wy_left, Graphics.LEFT | Graphics.TOP );
		g.drawImage( imgRightWheel[mWheelFrameNumber], cockpit_x + cockpit_width - (16 + 24) * HPF8 / 256, wy_right, Graphics.LEFT | Graphics.TOP );
		// draw cockpit
		g.drawImage( imgCockpit, cockpit_x, cockpit_y, Graphics.LEFT | Graphics.TOP );
		// draw corners
		g.drawImage( imgLeftCorner, 0, 0, Graphics.LEFT | Graphics.TOP );
		g.drawImage( imgRightCorner, GameView.SCREEN_WIDTH - 22 * HPF8 / 256, 0, Graphics.LEFT | Graphics.TOP );
		// draw flame
		if( car.mIsBoostActivated ) {
			if( ++mFlameFrameNumber >= (int)(1000 / GameView.REFRESH_PERIOD / 8) ) {
				mFlameFrameNumber = 0;
				if( ++nFlameNumber >= 3 ) nFlameNumber = 0;
			}
			g.drawImage( imgLeftFlames[0 * 3 + nFlameNumber], cockpit_x + 32 * HPF8 / 256, cockpit_y + 8 * VPF8 / 256, Graphics.LEFT | Graphics.TOP );
			g.drawImage( imgLeftFlames[1 * 3 + nFlameNumber], cockpit_x + 47 * HPF8 / 256, cockpit_y + 7 * VPF8 / 256, Graphics.LEFT | Graphics.TOP );
			g.drawImage( imgLeftFlames[2 * 3 + nFlameNumber], cockpit_x + 58 * HPF8 / 256, cockpit_y + 1 * VPF8 / 256, Graphics.LEFT | Graphics.TOP );
			g.drawImage( imgLeftFlames[3 * 3 + nFlameNumber], cockpit_x + 71 * HPF8 / 256, cockpit_y + 0 * VPF8 / 256, Graphics.LEFT | Graphics.TOP );
			g.drawImage( imgRightFlames[0 * 3 + nFlameNumber], cockpit_right_x - (32 + 15) * HPF8 / 256, cockpit_y + 8 * VPF8 / 256, Graphics.LEFT | Graphics.TOP );
			g.drawImage( imgRightFlames[1 * 3 + nFlameNumber], cockpit_right_x - (47 + 15) * HPF8 / 256, cockpit_y + 7 * VPF8 / 256, Graphics.LEFT | Graphics.TOP );
			g.drawImage( imgRightFlames[2 * 3 + nFlameNumber], cockpit_right_x - (58 + 14) * HPF8 / 256, cockpit_y + 1 * VPF8 / 256, Graphics.LEFT | Graphics.TOP );
			g.drawImage( imgRightFlames[3 * 3 + nFlameNumber], cockpit_right_x - (71 + 9) * HPF8 / 256, cockpit_y + 0 * VPF8 / 256, Graphics.LEFT | Graphics.TOP );
		}
		// draw speed indicator
		g.setColor( 0xffff00 );
		g.fillRect( cockpit_x + 87 * HPF8 / 256, cockpit_y + 51 * HPF8 / 256, indicator_length, 2 * VPF8 / 256 );
		// start draw digit information
		g.setColor( 0 );
		// draw lap number
		mStrLap[1] = (char)(Math.max( car.mLap, 0 ) + '0');
		Support.drawChars( g, mStrLap, cockpit_x + 25 * HPF8 / 256, GameView.SCREEN_HEIGHT - (15 * VPF8 + 128) / 256);//cockpit_y + (62 * VPF8 + 128) / 256 );
		// draw boost reserve
		mStrBoost[1] = (char)(car.mBoostReserve / 100 + '0');
		mStrBoost[2] = (char)((car.mBoostReserve / 10) % 10 + '0');
		mStrBoost[3] = (char)(car.mBoostReserve % 10 + '0');
		Support.drawChars( g, mStrBoost, cockpit_x + 45 * HPF8 / 256, GameView.SCREEN_HEIGHT - (15 * VPF8 + 128) / 256);//cockpit_y + (62 * VPF8 + 128) / 256 );
		// draw speed digit
		//g.drawString( Integer.toString( speed ), cockpit_x + 24 * PF, cockpit_y + 72 * PF );
		// draw distance between cars
		if( /*! mIsPractice && */++mUpdateDistanceTimer >= (int)(1000 / GameView.REFRESH_PERIOD / 2) ) {
			mUpdateDistanceTimer = 0;
			int val = Car.sDistance;
			mStrDistance[0] = ' ';
			if( val < 0 ) {
				val = -val;
				mStrDistance[0] = '-';
			}
			mStrDistance[1] = (char)(val / 1000 + '0');
			mStrDistance[2] = (char)((val / 100) % 10 + '0');
			mStrDistance[3] = (char)((val / 10) % 10 + '0');
			mStrDistance[4] = (char)((val % 10) + '0');
		}
		Support.drawChars( g, mStrDistance, cockpit_x + 40 * HPF8 / 256, GameView.SCREEN_HEIGHT - (5 * VPF8 + 128) / 256);//cockpit_y + (72 * VPF8 + 128) / 256 );
		// flag
		if( isOpponentBehind ) {//car.mTravelDistance > mOpponentCar.mTravelDistance ) {
			g.drawImage( imgFlag, cockpit_x + 83 * HPF8 / 256, cockpit_y + (67 * VPF8 + 128) / 256, Graphics.LEFT | Graphics.TOP );
		}
		// watch
		Image img = imgWatch;
		if( mIsLapTimeImproved )
			img = imgLightWatch;
		g.drawImage( img, cockpit_x + 225 * HPF8 / 256, cockpit_y + 68 * VPF8 / 256, Graphics.LEFT | Graphics.TOP );
		// draw current time "min:sec.ms", 0:00.0
		if( car.mStartRaceTime != 0 ) {
			if( mShowLapTimeTimer <= 0 ) {
				convertMsToChars( (int)(System.currentTimeMillis() - car.mStartLapTime) / 10 );
			} else {
				mShowLapTimeTimer--;
			}
			Support.drawChars( g, mStrLapTime, 0, 6, cockpit_x + 254 * HPF8 / 256, GameView.SCREEN_HEIGHT - (15 * VPF8 + 128) / 256);//cockpit_y + (62 * VPF8 + 128) / 256 );
			// draw best lap time "min:sec.ms", 0:00.00
			Support.drawChars( g, mStrBestLapTime, cockpit_x + 254 * HPF8 / 256, GameView.SCREEN_HEIGHT - (5 * VPF8 + 128) / 256);//cockpit_y + (72 * VPF8 + 128) / 256 );
		}
		// draw steer
		final int steer_width = 10 * HPF8 / 256;
		final int steer_height = 5 * VPF8 / 256;
		if( (keys & (GameView.KEY_LEFT | GameView.KEY_RIGHT)) != 0 ) {
			final int steer_y = cockpit_y + cockpit_height - steer_height;
			g.drawImage( imgSteer, (GameView.SCREEN_WIDTH - steer_width) >> 1, steer_y, Graphics.LEFT | Graphics.TOP );
		}
		// damage
		if( car.mIsUpdateDamage ) renderDamage( g, car.mDamage );
	}
}
