public class Driver {
	/** 12 chars maximum */
	public char[] mName;
	public final String mPictureName;
	/** ORed driving styles */
	public final int mDrivingStyle;
	/** quantity of races */
	public int mRaced;
	/** win count. 2 points for win */
	public int mWins;
	/** best lap count. 1 point for best lap */
	public int mBestLaps;
	/**
	 * Driver with name, image and driving style
	 * @param name - driver's name, 12 symbols maximum.
	 * @param picture - image resource name.
	 * @param driving_style - ORed driving styles.
	 */
	public Driver(final char[] name, final String picture, int driving_style) {
		setName( name );
		mPictureName = picture;
		mDrivingStyle = driving_style;
		resetState();
	}
	//
	public final void setName(final char[] name) {
		mName = name;
		// Copy name to internal buffer. Max name length is 12 symbols.
		//final int length = Math.min( name.length, 12 );
		//mName = new char[length];
		//for( int i = 0; i < length; i++ ) {
		//	mName[i] = name[i];
		//}
	}
	/** Set to zero raced, wins, best laps */
	public final void resetState() {
		mRaced = 0;
		mWins = 0;
		mBestLaps = 0;
	}
	/** @return 1 point for every best lap and 2 points for won race */
	public final int getPoints() {
		return mBestLaps + (mWins << 1);
	}
}