
import java.io.DataInputStream;
import java.io.IOException;
import java.util.Hashtable;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * To implements absent methods
 */
public class Support {
	public static void loadProperties(Hashtable res, DataInputStream ir) {
		String str;
		try {
			while( (str = ir.readUTF()) != null ) {
				int s = str.indexOf('=');
				if( s > 0 ) {
					final String key = str.substring( 0, s++ ).trim();
					final String val = str.substring( s ).trim();
					res.put( key, val );
				}
			}
		} catch( IOException e ) {
		}
	}
	public static void fillPolygon(final Graphics g, int[] xPoints, int[] yPoints, int nPoints) {
		final int x1 = xPoints[0];
		final int y1 = yPoints[0];
		for( int i = 2; i < nPoints; i++ ) {
			g.fillTriangle( x1, y1, xPoints[i - 1], yPoints[i - 1], xPoints[i], yPoints[i] );
		}
	}
	public static void drawPolygon(final Graphics g, int[] xPoints, int[] yPoints, int nPoints) {
		for( int i = 1; i < nPoints; i++ ) {
			g.drawLine( xPoints[i - 1], yPoints[i - 1], xPoints[i], yPoints[i] );
		}
		g.drawLine( xPoints[0], yPoints[0], xPoints[nPoints - 1], yPoints[nPoints - 1] );
	}
	public static Image getScaledImage(final Image image, int width, int height) {
		final int src_width = image.getWidth();
		final int src_height = image.getHeight();
		if( width == src_width && height == src_height ) {
			return image;
		}
		final int[] srcARGB = new int[src_width * src_height];
		image.getRGB( srcARGB, 0, src_width, 0, 0, src_width, src_height );
		final int[] argb = new int[width * height];
		//
		final int width_scale_fp8 = (src_width << 8) / width;
		final int height_scale_fp8 = (src_height << 8) / height;
		//
		final int height_max_fp8 = height * height_scale_fp8 + 127;
		final int width_max_fp8 = width * width_scale_fp8 + 127;
		for( int h_fp8 = 127, offset = 0; h_fp8 < height_max_fp8; h_fp8 += height_scale_fp8 ) {
			final int src_offset = (h_fp8 >> 8) * src_width;
			for( int w_fp8 = 127; w_fp8 < width_max_fp8; w_fp8 += width_scale_fp8 ) {
				argb[offset++] = srcARGB[src_offset + (w_fp8 >> 8)];
			}
		}
		return Image.createRGBImage( argb, width, height, true );
	}
	private static MyFont sCurrentFont = null;
	public static void setFont(final MyFont font) {
		sCurrentFont = font;
	}
	public static MyFont getCurrentFont() {
		return sCurrentFont;
	}
	public static void drawChars(final Graphics g, final char[] text, int x, int y) {
		y -= sCurrentFont.mBaseLine;
		for( int i = 0; i < text.length; i++ ) {
			x += sCurrentFont.drawChar( g, text[i], x, y );
		}
	}
	public static void drawChars(final Graphics g, final char[] text, int start, int end, int x, int y) {
		y -= sCurrentFont.mBaseLine;
		for( int i = start; i < end; i++ ) {
			x += sCurrentFont.drawChar( g, text[i], x, y );
		}
	}
}
